//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Classe abstraite de gestion de l'inteface utilisateur.
//    v:0.1 07/09/2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package vabase;

import java.awt.*;
import java.awt.event.*;

/**  Classe abstraite de gestion de l'inteface utilisateur */
public abstract class Cui extends Frame {
  /** pointeur sur l'applet de lancement */
  private Claunch appletMere;
  /** pointeur sur le processus */
  public Cprocess process;
  /** Constructeur par dfaut */
  public Cui() {
  }
  /** Constructeur dans une applet */
  public Cui(Claunch am) {
    super(am.getName()+" "+am.getVersionNum()+" "+am.getAuthor());
    appletMere=am;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Initialisation du composant */
  private void jbInit() throws Exception {
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
  }
  /** Initialisation du monde */
  public void start() {
    process.initVue();
  }
  /** Redimensionnement de la vue */
  public void redimUi() {
    if(process.isRunning) {
      synchronized (process) { process.stop(); }
      process.initVue();
      process.lancement();
    }
    else
      process.initVue();
  }
  /** Fermeture fentre */
  void this_windowClosing(WindowEvent e) {
    synchronized (process) { process.stop(); }
    process.vue.destroy();
    dispose();
  }
  /** gestion de l'interface selon marche/arrt */
  public abstract void setInterface(boolean e);
  /** Affichage de la gnration courante */
  public abstract void affGeneration();
}